#version 120

/* DRAWBUFFERS:13 */

uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;

uniform mat4 gbufferProjection;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;
uniform mat4 gbufferPreviousProjection;

uniform sampler2D colortex0;
uniform sampler2D colortex3;
uniform sampler2D depthtex1;

uniform float frameTime;
uniform float viewWidth;
uniform float viewHeight;
uniform float aspectRatio;

uniform int frameCounter;
uniform int isEyeInWater;

#define LENS_SETTINGS

#include "/lib/utilities.glsl"

struct inputStruct {

    vec4 colorTexture0;

} Input;

#include "/lib/utility/misc/ditherIndexMap.glsl"
#include "/lib/utility/misc/computeCameraVelocity.glsl"

#include "/lib/utility/post/TAA.glsl"
#include "/lib/utility/post/FXAA.glsl"

void main() {
    
    Input.colorTexture0 = textureLoad(colortex0, texCoord);
     
    vec2 newCoord = texCoord;

    #if ANTI_ALIASING == 1 || ANTI_ALIASING == 3
        FXAACompute(Input.colorTexture0.rgb, newCoord);
        
        #if ANTI_ALIASING == 1
            Input.colorTexture0.rgb = textureLoad(colortex0, newCoord).rgb;
        #endif
    #endif

	#if ANTI_ALIASING == 2 || ANTI_ALIASING == 3
    	TAACompute(Input.colorTexture0.rgb, newCoord);
	#endif

    gl_FragData[0] = vec4(to16F(Input.colorTexture0));
    gl_FragData[1] = vec4(Input.colorTexture0.rgb, textureLoad(colortex3, texCoord).a);
}