// Post Process Start //

    #define ADVANCED_FILTERING

    // Crepuscular Rays Start //

        #define CREPUSCULAR_RAYS 2 // [ 0 1 2 3 ]
        #define CREPUSCULAR_RAYS_SAMPLES 4 // [ 4 8 ]
        #define CREPUSCULAR_RAYS_3D_DEPTH 16 // [ 16 32 ]
        
        //#define CREPUSCULAR_RAYS_SHADOW_FILTER
        #define CREPUSCULAR_RAYS_CAUSTIC_RAYS

    // Crepuscular Rays End //

    // Anti Aliasing Start //

        #define ANTI_ALIASING 2 // [ 0 1 2 3 ]

    // Anti Aliasing End //

    // Light Physics Start //

        #define AMBIENT_OCCLUSION
        #define SKYLIGHT_DIFFUSE
        //#define SUNLIGHT_BOUNCE

        // Sunlight Shadows  Start //

            #define SHADOW_WATER_CAUSTICS
            #define SHADOW_COLORED_SHADOWS

            #define SHADOW_FILTER 1 // [ 0 1 2 ]

            #define SHADOW_FILTER_BLUR_SIZE 0.5 // [ 0.25 0.5 0.75 1.0 1.25 1.5 1.75 2.0 ]
            #define SHADOW_FILTER_SAMPLES 8 // [ 8 16 ]

        // Sunlight Shadows End //

    // Light Physics End //

    // Lens Physics Start //

        #define LENS_EFFECT_SAMPLES 8 // [ 8 16 ]

        #define LENS_GLARE_TYPE 0 // [ 0 1 ]
        #define LENS_FLARE_TYPE 0 // [ 0 1 2 ]

        //#define LENS_DIFFRACTION
        //#define LENS_GLARE
        //#define LENS_DIRT

        #define REFRACTION_LENS_DISTORTION
        //#define REFRACTION_CHROMATIC_ABERRATION
        #define REFRACTION_CHROMATIC_DISPERSION
        
        // Depth Of Field Start //

            //#define DEPTH_OF_FIELD
            //#define BARREL_DISTORTION
            //#define DEPTH_AWARE_BLUR
            //#define TILT_SHIFT
            #define DEPTH_OF_FIELD_SAMPLE_CUTOFF
            #define DEPTH_OF_FIELD_VARIABLE_SAMPLES
            
        // Depth Of Field End //

        // Bloom Start //

            #define BLOOM

            #define BLOOM_TILES 6 // [ 6 7 ]

        // Bloom End //

    // Lens Physics End //

    // Motion Blur Start //

        #define MOTIONBLUR

    // Motion Blur End //

// Post Process End//

// Atmospherics Start //

    #define STARS

    #define CLOUDS 2 // [ 1 2 3 4 ]

    #define WATER_FOG

// Atmospherics End //

// Light Refraction Start //

    #define WATER_NORMALS
    
    //#define WATER_PARALLAX_WAVES

    #define REFRACTION
    #define REFRACTION_RAIN_DROPS
    #define REFRACTION_HEAT_WAVES
    #define REFRACTION_WATER_WAVES
    #define REFRACTION_UNDERWATER_DISTORTION

    //#define WATER_REPROJECTION

// Light Refraction End //

// Reflections Start //

    #define WATER_REFLECTIONS

    #define WATER_REFLECTION_REFINEMENTS 6 // [ 3 6 9 12 15 ]
    #define WATER_REFLECTION_LAYERS 2 // [ 1 2 3 4 ]
    #define WATER_REFLECTION_RAYS 25 // [ 20 25 30 35 40 ]
    #define WATER_REFLECTION_TYPE 1 // [ 0 1 ]

    #define WATER_ANISOTROPIC_SAMPLES 2 // [ 2 4 ]

// Reflections End //

// Internals Start //

    #define VERTEX_DISPLACEMENT
    
    #define UNIFIED_LIGHTING_SAMPLES 2 // [ 2 4 6 8 ]
 
    // Texture Effect Start //

        //#define UNIVERSAL_PARALLAX
        //#define UNIVERSAL_BUMP

        #define PARALLAX_DISTANCE 96 // [ 32 48 64 80 96 112 128 144 160 176 192 208 224 240 256 272 288 304 320 336 352 368 384 400 416 432 448 464 480 496 512 528 544 560 576 592 608 624 640 656 672 688 704 720 736 752 768 784 800 816 832 848 864 880 896 912 928 944 960 976 992 1008 1024 ]
        #define PARALLAX_LAYERS 256 // [ 64 128 256 512 1024 ]
        #define PARALLAX_HEIGHT 0.25 // [ 0.25 0.5 0.75 1.0 ]

        #define PARALLAX_MODE 1 // [ 0 1 ]
        #define BUMP_MODE 1 // [ 0 1 ]

    // Texture Effect End //

    // Composite Scale Start //

        //#define ADAPTIVE_SCALING
        
        #define COMPOSITE_RES 0.7 // [ 0.6 0.65 0.7 0.75 0.8 0.85 0.9 0.95 1.0 ]

        #define FPS_TARGET 60 // [ 30 60 75 100 120 144 165 180 200 240 ]

    // Composite Scale End //

// Internals End //

// Aesthetic Start //

    //#define CAMERA_ARTIFACT_CORRECTION
    #define AUTO_EXPOSURE
    #define AUTO_FOCUS

    #define APERTURE 5.6 // [ 1.0 1.4 2.0 2.8 4.0 5.6 8.0 11.0 16.0 22.0 ]
    #define EV_MULTIPLIER 1.0 // [ 0.75 1.0 1.25 ]

    #define SHUTTER_SPEED 250 // [ 2000 1500 1000 750 500 350 250 180 125 90 60 ]

    #define ISO 400 // [ 3 6 12 25 50 100 200 400 800 1600 ]

    #define FOCAL_LENGTH 35 // [ 20 25 30 35 40 45 50 55 60 65 70 75 ]

    #define ROTATION 0.0 // [ 0.0 0.25 0.5 0.75 1.0 ]
    #define ROUNDING 0.0 // [ 0.0 0.25 0.5 0.75 1.0 ]

    #define BLADES 5  // [ 3 4 5 6 7 8 9 10 11 12 13 14 15 16 ]
    #define RINGS 1 // [ 1 2 3 4 5 6 ]

    #define DEPTH_VALUE 0.990 // [ 0.800 0.801 0.802 0.803 0.804 0.805 0.806 0.807 0.808 0.809 0.810 0.811 0.812 0.813 0.814 0.815 0.816 0.817 0.818 0.819 0.820 0.821 0.822 0.823 0.824 0.825 0.826 0.827 0.828 0.829 0.830 0.831 0.832 0.833 0.834 0.835 0.836 0.837 0.838 0.839 0.840 0.841 0.842 0.843 0.844 0.845 0.846 0.847 0.848 0.849 0.850 0.851 0.852 0.853 0.854 0.855 0.856 0.857 0.858 0.859 0.860 0.861 0.862 0.863 0.864 0.865 0.866 0.867 0.868 0.869 0.870 0.871 0.872 0.873 0.874 0.875 0.876 0.877 0.878 0.879 0.880 0.881 0.882 0.883 0.884 0.885 0.886 0.887 0.888 0.889 0.890 0.891 0.892 0.893 0.894 0.895 0.896 0.897 0.898 0.899 0.900 0.901 0.902 0.903 0.904 0.905 0.906 0.907 0.908 0.909 0.910 0.911 0.912 0.913 0.914 0.915 0.916 0.917 0.918 0.919 0.920 0.921 0.922 0.923 0.924 0.925 0.926 0.927 0.928 0.929 0.930 0.931 0.932 0.933 0.934 0.935 0.936 0.937 0.938 0.939 0.940 0.941 0.942 0.943 0.944 0.945 0.946 0.947 0.948 0.949 0.950 0.951 0.952 0.953 0.954 0.955 0.956 0.957 0.958 0.959 0.960 0.961 0.962 0.963 0.964 0.965 0.966 0.967 0.968 0.969 0.970 0.971 0.972 0.973 0.974 0.975 0.976 0.977 0.978 0.979 0.980 0.981 0.982 0.983 0.984 0.985 0.986 0.987 0.988 0.989 0.990 0.991 0.992 0.993 0.994 0.995 0.996 0.997 0.998 0.999 1.000 ]
    #define COLOR_TEMPERATURE 5500 // [ 2300 2400 2500 2600 2700 2800 2900 3000 3100 3200 3300 3400 3500 3600 3700 3800 3900 4000 4100 4200 4300 4400 4500 4600 4700 4800 4900 5000 5100 5200 5300 5400 5500 5600 5700 5800 5900 6000 6100 6200 6300 6400 6500 6600 6700 6800 6900 7000 7100 7200 7300 7400 7500 7600 7700 7800 7900 8000 8100 8200 8300 8400 8500 8600 8700 8800 8900 9000 9100 9200 9300 9400 9500 9600 9700 9800 9900 10000 ]
        
    #define COLOR_FILTER 0 // [ 0 1 2 3 4 ]

// Aesthetic End //