vec2 computeParallaxCoord(in mat2x2 wrapTexture, in vec3 vertexPos) {

    vec2 parallaxCoord = texCoord;

    if (vertexPos.z < 0.0 && fLength(vertexPos) < PARALLAX_DISTANCE) {

        parallaxCoord = parallaxData[2];
        
        vec3 parallaxStep = vertexPos / PARALLAX_LAYERS;

        parallaxStep.z *= 16 / PARALLAX_HEIGHT;

        for (int i = 0; i < PARALLAX_LAYERS; ++i) {

            parallaxCoord += parallaxStep.xy;

            #if PARALLAX_MODE == 0
                if (fLength(texture2DGradARB(texture, fract(parallaxCoord) * parallaxData[0] + parallaxData[1], wrapTexture[0], wrapTexture[1]).rgb) > parallaxStep.z * i + 1.0) break;
            #else
                if (texture2DGradARB(normals, fract(parallaxCoord) * parallaxData[0] + parallaxData[1], wrapTexture[0], wrapTexture[1]).a > parallaxStep.z * i + 1.0) break;
            #endif

        }

        parallaxCoord = fract(parallaxCoord) * parallaxData[0] + parallaxData[1];
        
    }

    return texture2D(texture, texCoord).a < 1.0 ? texCoord : parallaxCoord;
}