void computeBloomTile(inout vec3 tile, const in int index) {

	#ifndef MC_GL_VENDOR_ATI
		const float tileScale = exp2(2.0 + index);
		const float doubleScale = tileScale * 2.0;

		const float LOD = log2(tileScale);
	#else
		float tileScale = exp2(2.0 + index);
		float doubleScale = tileScale * 2.0;

		float LOD = log2(tileScale);
	#endif

	vec2 padding = sqrt(screenPixelsSize * LOD) * 0.5;

	vec2 bloomCoordinate = downScale(texCoord, tileScale, bloomTilePositions[index] * (padding * 8.0 + 1.0));
	
	if (!coordInTile(bloomCoordinate, padding)) return;

	int fakeIncrement = frameCounter & (index * 2);

	float circularWeight = 0.0;

	for (int i = 0; i < tileScale; ++i) {
		
		circularWeight = (doubleScale / (doubleScale - abs(i - tileScale)));

		if (circularWeight <= 0.0) continue;

		tile = linear(textureLoadLOD(colortex1, rotatePoint(i * phi + fakeIncrement) * screenPixelsSize + bloomCoordinate, LOD).rgb) * circularWeight + tile;

	}

	tile /= doubleScale;
}