void fetchBloomTile(inout vec3 tile, const in int index) {
	
	#ifndef MC_GL_VENDOR_ATI
		const float tileScale = exp2(2.0 + index);

		const float tileScaleSq = sqrt(tileScale);
	#else
		float tileScale = exp2(2.0 + index);

		float tileScaleSq = sqrt(tileScale);
	#endif

	vec2 tileCoord = upScale(screenPixelsSize * pow2(index) + texCoord, tileScale, bloomTilePositions[index] * (sqrt(log2(tileScale) * screenPixelsSize) * 4.0 + 1.0));

	vec3 currentTile = vec3(0.0);

	#ifdef ADVANCED_FILTERING
		if (index <= 6) currentTile = (textureLoadLOD(colortex1, tileCoord, 1).rgb / 7.0) * tileScaleSq + currentTile;
		if (index <= 5) currentTile = (textureLoadLOD(colortex1, tileCoord, 2).rgb / 6.0) * tileScaleSq + currentTile;
		if (index <= 4) currentTile = (textureLoadLOD(colortex1, tileCoord, 3).rgb / 5.0) * tileScaleSq + currentTile;
		if (index <= 3) currentTile = (textureLoadLOD(colortex1, tileCoord, 4).rgb / 4.0) * tileScaleSq + currentTile;
		if (index <= 2) currentTile = (textureLoadLOD(colortex1, tileCoord, 5).rgb / 3.0) * tileScaleSq + currentTile;
		if (index <= 1) currentTile = (textureLoadLOD(colortex1, tileCoord, 6).rgb / 2.0) * tileScaleSq + currentTile;
		if (index <= 0) currentTile =  textureLoadLOD(colortex1, tileCoord, 7).rgb  	  * tileScaleSq + currentTile;
	#else
		currentTile = textureLoadLOD(colortex1, tileCoord, 0).rgb * tileScaleSq / 7.0;
	#endif

	tile = linear(currentTile) * tileScale + tile;

}