const float waveSharpness = 1.5;
const float waveDensity = 0.4;

const float stepIntensity = 0.75;
const float weightIntensity = 2.0;
const float sharpnessIntensity = 0.3;
const float waveIntensity = 0.035;

const vec2 sharpness = vec2(waveSharpness * waveDensity, waveDensity / waveSharpness);

float getWaves(in vec3 worldSpacePosition) {

    float waterWaves = 0.0;

    float detailSharpness = 0.9;
    float detailWeight = 3.5;
    float detailStep = 2.45;

    float rotationDegrees = pi * 0.35;

    vec2 movement = vec2(time * 0.58, -time * 0.43);

    for (int i = 0; i < 2; ++i) {

        if ((i & 0x00000001) > 0)

        rotationDegrees = -(rotationDegrees * (i & 0x00000001));

        else

        movement = -movement;

        vec2 rotatedRefractCoord = rotateVector(worldSpacePosition.xz, rotationDegrees) * sharpness;
        
        waterWaves = generate2DNoise(rotatedRefractCoord - movement) * waveIntensity + waterWaves;

        vec2 detailRefractCoord = (rotatedRefractCoord - movement) * vec2(detailSharpness * detailStep, detailStep / detailSharpness);

        waterWaves = generate2DNoise(detailRefractCoord) * (waveIntensity / detailWeight) + waterWaves;

        detailStep = detailStep * stepIntensity + detailStep;
        detailWeight = detailWeight * weightIntensity + detailWeight;
        detailSharpness = detailSharpness * sharpnessIntensity + detailSharpness;

        detailRefractCoord = rotatedRefractCoord;

    }

    return waterWaves;
}