#version 120

#define VERTEX

attribute vec4 mc_Entity;
attribute vec4 mc_midTexCoord;

varying vec4 biomeColor;

varying vec3 vertexPos;

varying vec3 vertexNormal;

flat varying float vertexID;

uniform vec3 cameraPosition;

uniform mat4 shadowModelView;
uniform mat4 shadowModelViewInverse;

uniform float frameTimeCounter;

#include "/lib/utilities.glsl"

#include "/lib/asset/shadow.glsl"

#include "/lib/utility/misc/displaceVertex.glsl"

void main() {

	texCoord 	  = gl_MultiTexCoord0.xy;
	biomeColor    = gl_Color;
	vertexID      = mc_Entity.x;
	vertexNormal  = gl_NormalMatrix * gl_Normal;
	
	vec2 lightmap = gl_MultiTexCoord1.xy * rcp8bit + rcp8bit;

	gl_Position.xyz = transMAD(shadowModelViewInverse, transMAD(gl_ModelViewMatrix, gl_Vertex.xyz));

	vertexPos = gl_Position.xyz + cameraPosition;

	#ifdef VERTEX_DISPLACEMENT
		if (
		mc_Entity.x == 141.0 ||
		mc_Entity.x == 142.0 ||
		mc_Entity.x == 115.0 ||
		mc_Entity.x == 105.0 ||
		mc_Entity.x == 104.0 ||
		mc_Entity.x == 59.0  ||
		mc_Entity.x == 51.0  ||
		mc_Entity.x == 40.0  ||
		mc_Entity.x == 39.0  ||
		mc_Entity.x == 38.0  ||
		mc_Entity.x == 37.0  ||
		mc_Entity.x == 31.0  ||
		mc_Entity.x == 32.0  ||
		mc_Entity.x == 30.0  ||
		mc_Entity.x == 6.0	 )
		displaceVertex(gl_Position.xyz, lightmap.y * 0.75, true);

		if (
		mc_Entity.x == 175.0 ||
		mc_Entity.x == 161.0 || 
		mc_Entity.x == 106.0 ||
		mc_Entity.x == 83.0  ||
		mc_Entity.x == 18.0  )
		displaceVertex(gl_Position.xyz, lightmap.y * 0.25, false);

		if (
		mc_Entity.x == 141.0 ||
		mc_Entity.x == 142.0 ||
		mc_Entity.x == 115.0 ||
		mc_Entity.x == 59.0  ||
		mc_Entity.x == 38.0  ||
		mc_Entity.x == 37.0  ||
		mc_Entity.x == 31.0  &&
		texCoord.y < mc_midTexCoord.y) {

			float positionLength = fLength(gl_Position.xyz);

			if (positionLength < 1.0) gl_Position.xz *= 2.0 - min(positionLength, 1.0);

		}
	#endif

	gl_Position = transMAD(shadowModelView, gl_Position.xyz).xyzz * diagonal4(gl_ProjectionMatrix) + vec4(0, 0, gl_ProjectionMatrix[3].zw);

    gl_Position.xyz = distortShadowSpace(gl_Position.xyz, shadowDistanceSize, inverseDistanceSize);
}